/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// EventSubscriptionInput Sets the communication endpoint address the service instance must use to deliver notification information
type EventSubscriptionInput struct {
	// The callback being registered.
	Callback string `json:"callback"`
	// additional data to be passed
	Query *string `json:"query,omitempty"`
}

// NewEventSubscriptionInput instantiates a new EventSubscriptionInput object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewEventSubscriptionInput(callback string, ) *EventSubscriptionInput {
	this := EventSubscriptionInput{}
	this.Callback = callback
	return &this
}

// NewEventSubscriptionInputWithDefaults instantiates a new EventSubscriptionInput object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewEventSubscriptionInputWithDefaults() *EventSubscriptionInput {
	this := EventSubscriptionInput{}
	return &this
}

// GetCallback returns the Callback field value
func (o *EventSubscriptionInput) GetCallback() string {
	if o == nil  {
		var ret string
		return ret
	}

	return o.Callback
}

// GetCallbackOk returns a tuple with the Callback field value
// and a boolean to check if the value has been set.
func (o *EventSubscriptionInput) GetCallbackOk() (*string, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.Callback, true
}

// SetCallback sets field value
func (o *EventSubscriptionInput) SetCallback(v string) {
	o.Callback = v
}

// GetQuery returns the Query field value if set, zero value otherwise.
func (o *EventSubscriptionInput) GetQuery() string {
	if o == nil || o.Query == nil {
		var ret string
		return ret
	}
	return *o.Query
}

// GetQueryOk returns a tuple with the Query field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EventSubscriptionInput) GetQueryOk() (*string, bool) {
	if o == nil || o.Query == nil {
		return nil, false
	}
	return o.Query, true
}

// HasQuery returns a boolean if a field has been set.
func (o *EventSubscriptionInput) HasQuery() bool {
	if o != nil && o.Query != nil {
		return true
	}

	return false
}

// SetQuery gets a reference to the given string and assigns it to the Query field.
func (o *EventSubscriptionInput) SetQuery(v string) {
	o.Query = &v
}

func (o EventSubscriptionInput) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["callback"] = o.Callback
	}
	if o.Query != nil {
		toSerialize["query"] = o.Query
	}
	return json.Marshal(toSerialize)
}

type NullableEventSubscriptionInput struct {
	value *EventSubscriptionInput
	isSet bool
}

func (v NullableEventSubscriptionInput) Get() *EventSubscriptionInput {
	return v.value
}

func (v *NullableEventSubscriptionInput) Set(val *EventSubscriptionInput) {
	v.value = val
	v.isSet = true
}

func (v NullableEventSubscriptionInput) IsSet() bool {
	return v.isSet
}

func (v *NullableEventSubscriptionInput) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableEventSubscriptionInput(val *EventSubscriptionInput) *NullableEventSubscriptionInput {
	return &NullableEventSubscriptionInput{value: val, isSet: true}
}

func (v NullableEventSubscriptionInput) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableEventSubscriptionInput) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


